from OpenGL.GL import *

class AnimatedObject:
	objectName = None
	aBox = None
	def __init__(self):
		self.frame = 0
		self.frames = 0
		self.posx = 0
		self.posy = 0
		self.sizex = 2
		self.sizey = 2
		self.visible = False
		self.offset = (0,0)

	def setPos(self,x,y):
		self.posx = x
		self.posy = y

	def setAnimationBox(cls,aBox):
		AnimatedObject.aBox = aBox

	def setAnimation(self,name,delay):
		self.animationName = str(self.objectName) + '-' + name
	#	print (self.animationName, name)
		self.frame = 0
		self.time = 0
		self.delay = delay
		self.frames = self.aBox.getNumberOfFrames( self.animationName)


	def update(self,timeDelta):
		self.time+=timeDelta
		if self.time > self.delay:
			self.frame = (self.frame+1) % self.frames
			self.time-=self.delay

	def render(self):
		if self.visible:
			glBindTexture(GL_TEXTURE_2D,self.aBox.getFrameTexture(self.animationName, self.frame+1))
			glBegin(GL_QUADS)
			glTexCoord2f(0,0); glVertex3d(self.posx-self.sizex+self.offset[0],self.posy-self.sizey+self.offset[1],0)
			glTexCoord2f(1,0); glVertex3d(self.posx+self.sizex+self.offset[0],self.posy-self.sizey+self.offset[1],0)
			glTexCoord2f(1,1); glVertex3d(self.posx+self.sizex+self.offset[0],self.posy+self.sizey+self.offset[1],0)
			glTexCoord2f(0,1); glVertex3d(self.posx-self.sizex+self.offset[0],self.posy+self.sizey+self.offset[1],0)
			glEnd()
		#print (self.posx, self.posy)

	setAnimationBox = classmethod(setAnimationBox)
