
from OpenGL.GL import *

import texturebox

class Font:
	def __init__(self,texture):
		self.tex = texture
		charstring = "ABCDEFGHJIKLMNOPQRSTUVWXYZ{}()<>abcdefghjiklmnopqrstuvwxyz,.:;!?@#%&*-_|[]\'/\\`=+$1234567890 ^"
		self.map={}
		i = 0
		for c in charstring:
			self.map[c] = i
			i=i+1

	def renderChar(self,char,x,y,width,height):
		no = self.map[char]
		tx = no % 16 
		ty = (15 - no / 16) 
		glBindTexture(GL_TEXTURE_2D,self.tex)
		glBegin(GL_QUADS)
		glTexCoord2d(tx/16.0,ty/16.0)    ; glVertex3d(x,y,-1)
		glTexCoord2d((tx+1)/16.0,ty/16.0); glVertex3d(x+width,y,-1)
		glTexCoord2d((tx+1)/16.0,(ty+1)/16.0); glVertex3d(x+width,y+height,-1)
		glTexCoord2d(tx/16.0,(ty+1)/16.0); glVertex3d(x,y+height,-1)
		glEnd()


	def renderString(self,string,x,y,width,height,cspace,lspace):
		lx = x
		ly = y
		for char in string:
			if char!='\n':
				self.renderChar(char,lx,ly,width,height)
				lx+=cspace
			else:
				lx = x			
				ly-=lspace




