from OpenGL.GL import *

import texturebox
import font

sign = lambda x: cmp(x,0)
class Menu:
	def __init__(self):
		self.state = 'disabled'
		self.done = True
		self.items = [] 
		self.current = 0	
		self.equipped = 0
		self.size = 0
		self.offset = 0
		self.desiredAngle = 0
		self.enabled = True
		self.updating = False
		self.steps = 20
		self.delay = 2 
		self.time = 0

	def setTextureBox(self,tBox):
		self.tBox = tBox
		tBox.load("choice")
		tBox.load("black")
		self.font = font.Font(tBox.get("charmap"))

	def enable(self):
		self.state = 'fadein'
		self.enabled = True

	def disable(self):
		self.state = 'fadeout'
		self.enabled = False

	def addMenuItem(self,item,texture):
		self.items.append((item, texture))
		self.size+=1

	def next(self):
		if not self.updating:
			self.current = (self.current + 1) % self.size
			self.state = 'rotating'
			self.updatec()

	def previous(self):
		if not self.updating:
			self.current = (self.current - 1 + self.size) % self.size
			self.state = 'rotating'
			self.updatec()

	def select(self):
		""" Tell menu to mark selection and return selected item """
		self.equipped = self.current
		x,y = self.items[self.current]
		return x

	def isDone(self):
		""" Check if current action is done """
		return not self.updating

	def updatec(self):
		self.desiredAngle = self.current*360.0/self.size
		diff1 = (self.desiredAngle + self.offset +360) % 360
		diff2 = diff1 - 360 
	#	print (self.desiredAngle,self.offset,diff1,diff2)
		if abs(diff1) < abs(diff2) :
			diff = diff1
		else:
			diff = diff2

		self.step = diff/self.steps
		self.stepsLeft = self.steps
		self.updating = True
	
	def update(self,timeDelta):
	
		if self.updating:
			self.time += timeDelta
			if self.time > self.delay:
				self.time-=self.delay
				self.offset -= ((self.step)+360) % 360.0
				self.offset = (self.offset+360) % 360.0
				self.stepsLeft-=1
				if not self.stepsLeft:
					self.updating = False

	def render(self):
		r = 2
		if not self.enabled:
			return

		glBindTexture(GL_TEXTURE_2D,self.tBox.get("black"))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(-10,-10,0)
		glTexCoord2f(1,0); glVertex3f(10,-10,0)
		glTexCoord2f(1,1); glVertex3f(10,10,0)
		glTexCoord2f(0,1); glVertex3f(-10,10,0)
		glEnd()

		glPushMatrix()
		glTranslated(0,r,-1)

		glBindTexture(GL_TEXTURE_2D,self.tBox.get("choice"))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0); glVertex3f(-0.7,-0.7,0)
		glTexCoord2f(1,0); glVertex3f(0.7,-0.7,0)
		glTexCoord2f(1,1); glVertex3f(0.7,0.7,0)
		glTexCoord2f(0,1); glVertex3f(-0.7,0.7,0)
		glEnd()

		glPopMatrix()

		for i in range(self.size):
			(name,tex) = self.items[i]
			angle = i*360.0/self.size + self.offset
			# Gray area out


			# Do rotation
			glPushMatrix()
			glRotated(angle,0,0,-1)
			glTranslated(0,r,-2)
			glRotated(-angle,0,0,-1)
			glBindTexture(GL_TEXTURE_2D,self.tBox.get(tex))
			glBegin(GL_QUADS)
			glTexCoord2f(0,0); glVertex3f(-0.5,-0.5,0)
			glTexCoord2f(1,0); glVertex3f(0.5,-0.5,0)
			glTexCoord2f(1,1); glVertex3f(0.5,0.5,0)
			glTexCoord2f(0,1); glVertex3f(-0.5,0.5,0)
			glEnd()
#			if i==self.equipped: 
#				glBindTexture(GL_TEXTURE_2D,self.tBox.get("equipped"))
#				glBegin(GL_QUADS)
#				glTexCoord2f(0,0); glVertex3f(-0.5,-0.5,-1)
#				glTexCoord2f(1,0); glVertex3f(0.5,-0.5,-1)
#				glTexCoord2f(1,1); glVertex3f(0.5,0.5,-1)
#				glTexCoord2f(0,1); glVertex3f(-0.5,0.5,-1)
#				glEnd()

				
			glPopMatrix()
			


	def __str__(self):
		return str(self.items[self.current])

def main():
	print "Menu test"
	m = Menu()
	m.addMenuItem("Test1Item","Test1Texture")
	m.addMenuItem("Test2Item","Test2Texture")
	m.addMenuItem("Test3Item","Test3Texture")
	m.addMenuItem("Test4Item","Test4Texture")
	print(m)
	for i in range(7):
		m.next()	
		print(m)	
	for i in range(7):
		m.previous()
		print(m)

if __name__ == '__main__':
	main()
